/*******************************************************************************
**	File:			ioctls.h
**	Author:			Hasan Jamal
**	
**
**	Description:
**		ioctls declaration include file
**
**	Copyright (c) 2011, CTI, Connect Tech Inc. All Rights Reserved.
**
**	THIS IS THE UNPUBLISHED PROPRIETARY SOURCE CODE OF CONNECT TECH INC.
**	The copyright notice above does not evidence any actual or intended
**	publication of such source code.
**
**	This module contains Proprietary Information of Connect Tech, Inc
**	and should be treated as Confidential.
******************************************************************************/

#ifndef _cti_fpga_drv_ioctls_h
#define _cti_fpga_drv_ioctls_h

#define FIFO	1
#define IOMEM	2
#define PCI_CFG	3

#pragma pack(push,1)
struct ioctl_read_cfg_io {
	char io_type; //  to indicate whether request is for IO, FIFO or PCI Config
	int bar_index;
	int offset;
	int size_data;
	char *data;	
};

struct ioctl_intr {
	int bar_index;
	int offset;
	char bitnum;
	char polarity;
	int timeout_ms;	
};
#pragma pack(pop)

#if defined(_WIN32) || defined(_WIN64)

#define IOCTL_UFPGA 40000

// The IOCTL function codes from 0x800 to 0xFFF are for customer use.

// input parameter is 'struct ioctl_read_cfg_io', output parameter is none
#define IOCTL_READ_IO_CFG \
    CTL_CODE( IOCTL_UFPGA, 0x900, METHOD_BUFFERED, FILE_READ_ACCESS )

// input parameter is 'struct ioctl_read_cfg_io', output parameter is none
#define IOCTL_WRITE_IO_CFG \
    CTL_CODE( IOCTL_UFPGA, 0x901, METHOD_BUFFERED, FILE_WRITE_ACCESS )

// input parameter is none, output parameter is UFPGA_BOARDINFO
#define IOCTL_UFPGA_GET_BOARD_INFO \
    CTL_CODE( IOCTL_UFPGA, 0x902, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_WAITINTR \
    CTL_CODE( IOCTL_UFPGA, 0x903, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#else

#define IOCTL_READ_IO_CFG		0x54A1  /* Get IO or PCI CFG data */
#define IOCTL_WRITE_IO_CFG		0x54A2  /* Set IO or PCI CFG data */
#define IOCTL_GET_BOARD_INFO	0x54A3  /* Set IO or PCI CFG data */
#define IOCTL_SHARE_PID			0x54A4	// to be defined
#define IOCTL_REINSTATE_IRQ		0x54A5	// to be defined
#define IOCTL_SHARE_FD			0x54A6	// to be defined
#define IOCTL_WAITINTR			0x54A7	// wait on an interrupt
#endif

#endif
